/*****************************************************************
claim_count.do

This collapses the raw LTCH MEDPAR files to create claim counts for each 
hospital*year.  
*****************************************************************/
clear all
cap log close
set more off
set mem 12000m

cd /net/storage-01/econ/research/jr139/LTCH
log using work/datawork/claim_count.txt, text replace

foreach yr in 02 04 05 06 07 08 09 10 11 12 13 14 15 {
disp "`yr'"
clear
insheet using data/ltch/ltch_csv/MEDPAR_LTCH_LDS_20`yr'.csv,delimiter(",")
cap drop if real(medpar_provider_number)==.
cap drop if medpar_provider_number==.
destring(medpar_provider_number),replace
gen prov_id = string(medpar_provider_number,"%06.0f")

gen fyear = 2000+`yr'

gen claim_cnt = 1

sort prov_id fyear
collapse (sum) claim_cnt,by(prov_id fyear)
save data/ltch/ltch_csv/claim_counts`yr'.dta,replace
}

clear
use data/ltch/ltch_csv/claim_counts15.dta,replace
append using data/ltch/ltch_csv/claim_counts14.dta,force
append using data/ltch/ltch_csv/claim_counts13.dta,force
append using data/ltch/ltch_csv/claim_counts12.dta,force
append using data/ltch/ltch_csv/claim_counts11.dta,force
append using data/ltch/ltch_csv/claim_counts10.dta,force
append using data/ltch/ltch_csv/claim_counts09.dta,force
append using data/ltch/ltch_csv/claim_counts08.dta,force
append using data/ltch/ltch_csv/claim_counts07.dta,force
append using data/ltch/ltch_csv/claim_counts06.dta,force
append using data/ltch/ltch_csv/claim_counts05.dta,force
append using data/ltch/ltch_csv/claim_counts04.dta,force
append using data/ltch/ltch_csv/claim_counts02.dta,force
tostring(prov_id),replace
sort prov_id fyear
save data/claim_counts_all.dta,replace

