/*******************************************************************
drg_data.do

Pulls DRG data into stata and preps for merging with the claims data.
*******************************************************************/
clear all
set more off
cap log close
set mem 12000m

cd ~/LTCH/
log using work/datawork/drg_data.txt,text replace

	
foreach yr in 04 05 06 07 08 09 10 11 12 13 {
	clear
	insheet using data/DRGs/DRG_LTCH_20`yr'.csv,delimit(",")
	gen year = 2000+`yr'
	tostring(drg),replace
	sort drg
	save data/DRGs/DRG_LTCH_20`yr'.dta,replace
}

clear 

use data/DRGs/DRG_LTCH_2004.dta
foreach yr in 05 06 07 08 09 10 11 12 13 {
	append using data/DRGs/DRG_LTCH_20`yr'.dta
}

keep drg description weight geo_mean sso_thresh year cases2006 cases2007 cases2008 cases2009 cases2010 cases2011
sort year drg
drop if drg==""
drop if drg=="."
save data/DRGs/DRG_LTCH_ALL.dta,replace
